## mediaelch-2.8.12-1.src.tar.gz

=== CMakeLists.txt ===
# cmake build of MediaElch

# Please note that CMake support is experimental.

# Uncomment this to see all commands cmake actually executes
# set(CMAKE_VERBOSE_MAKEFILE ON)

cmake_minimum_required(VERSION 3.13.0 FATAL_ERROR)

project(
  mediaelch
  VERSION 2.8.12
  DESCRIPTION "Media Manager for Kodi"
  HOMEPAGE_URL "https://mediaelch.github.io/"
)

message("=> Project: ${PROJECT_NAME}")

if(NOT "${CMAKE_C_COMPILER_ID}" STREQUAL "${CMAKE_CXX_COMPILER_ID}")
  message(
    FATAL_ERROR
      "Different compilers for C++ (${CMAKE_CXX_COMPILER_ID}) and C (${CMAKE_C_COMPILER_ID})!"
  )
endif()

# -----------------------------------------------------------------------------
# Set a default build type if none was specified
set(MEDIAELCH_DEFAULT_BUILD_TYPE "RelWithDebInfo")

# Git project? Most likely a development environment
if(EXISTS "${CMAKE_SOURCE_DIR}/.git")
  set(MEDIAELCH_DEFAULT_BUILD_TYPE "Debug")
endif()

if(NOT CMAKE_BUILD_TYPE AND NOT CMAKE_CONFIGURATION_TYPES)
  message(
    STATUS
      "Setting build type to '${MEDIAELCH_DEFAULT_BUILD_TYPE}' as none was specified."
  )
  set(CMAKE_BUILD_TYPE
      "${MEDIAELCH_DEFAULT_BUILD_TYPE}"
      CACHE STRING "Choose the type of build." FORCE
  )
  # Set the possible values of build type for cmake-gui
  set_property(
    CACHE CMAKE_BUILD_TYPE PROPERTY STRINGS "Debug" "Release" "MinSizeRel"
                                    "RelWithDebInfo"
  )
endif()

set(CMAKE_MODULE_PATH "${CMAKE_SOURCE_DIR}/cmake")

# -----------------------------------------------------------------------------
# Project configuration options. Sanitizer options are defined in the
# correspondig FindXX modules.
# cmake-format: off
option(ENABLE_CLANG_TIDY       "Analyze code with clang-tidy."                       OFF)
option(ENABLE_CLANG_TIDY_FIX   "Analyze code with clang-tidy and fix errors."        OFF)
option(ENABLE_COVERAGE         "Add coverage information to binaries."               OFF)
option(ENABLE_COLOR_OUTPUT     "Force produce ANSI-colored output (GNU/Clang only)."  ON)
option(ENABLE_LTO              "Enable link-time-optimization. Increases link time." OFF)
option(DISABLE_UPDATER         "Disable MediaElch's update check."                   OFF)
option(USE_EXTERN_QUAZIP       "Build against the system's quazip library."          OFF)
# cmake-format: on

find_package(Sanitizers)
include(warnings)
include(coverage)
include(clang-tidy)
include(colors)

activate_coverage(ENABLE_COVERAGE)

# -----------------------------------------------------------------------------
# Optional IPO. Do not use IPO if it's not supported by compiler. IPO is
# interprocedural optimization (also known as link-time-optimization).
if(ENABLE_LTO)
  include(CheckIPOSupported)
  check_ipo_supported() # fatal error if IPO/LTO is not supported
  message(STATUS "Using LTO")
endif()

set(LINK_WHAT_YOU_USE ON)

# -----------------------------------------------------------------------------
# Some defaults for our targets. Currently warnings are enabled and the C++
# standard is set to C++14 (or 17 for Qt6). It simplifies handling multiple
# targets like different libraries without having to repeat all
# compile-features, etc.
function(mediaelch_post_target_defaults target)
  if(NOT TARGET ${target})
    message(WARNING "MediaElch defaults: ${target} is not a target.")
    return()
  endif()
  if(NOT Qt6_FOUND)
    target_compile_features(${target} PUBLIC cxx_std_14)
  else()
    target_compile_features(${target} PUBLIC cxx_std_17)
  endif()
  target_include_directories(
    ${target} PUBLIC "${CMAKE_BINARY_DIR}" "${CMAKE_SOURCE_DIR}"
                     "${CMAKE_SOURCE_DIR}/src"
  )
  enable_warnings(${target})
  target_enable_coverage(${target})
  add_sanitizers(${target})
  if(ENABLE_LTO)
    set_property(TARGET ${target} PROPERTY INTERPROCEDURAL_OPTIMIZATION TRUE)
  endif()
  if(USE_EXTERN_QUAZIP)
    target_compile_definitions(${target} PRIVATE EXTERN_QUAZIP)
  endif()
  if(NOT DISABLE_UPDATER)
    target_compile_definitions(${target} PRIVATE MEDIAELCH_UPDATER)
  endif()
endfunction()

# ------------------------------------------------------------------------------

set(CMAKE_AUTOMOC ON) # Instruct CMake to run moc automatically when needed
set(CMAKE_AUTOUIC ON) # Create code from a list of Qt designer ui files
set(CMAKE_AUTORCC ON) # For .qrc files

# Min version required; keep in sync with MediaElch.plist macOS 10.14 is
# required for some std::variant features required by Qt.
if(NOT Qt6_FOUND)
  set(CMAKE_OSX_DEPLOYMENT_TARGET 10.14)
else()
  set(CMAKE_OSX_DEPLOYMENT_TARGET 10.13)
endif()

# ------------------------------------------------------------------------------
# Qt5/6: You may need to set CMAKE_PREFIX_PATH e.g. to ~/Qt/5.11.2/gcc_64/
find_package(
  QT NAMES Qt6 Qt5
  COMPONENTS Core
  REQUIRED
)

find_package(
  Qt${QT_VERSION_MAJOR} QUIET REQUIRED
  COMPONENTS
    Concurrent
    Core
    Gui
    Multimedia
    MultimediaWidgets
    Network
    OpenGL
    Qml
    Quick
    QuickWidgets
    Sql
    Svg
    Widgets
    Xml
    LinguistTools
  OPTIONAL_COMPONENTS Test
)

# -----------------------------------------------------------------------------
# Translations

# Specify all *.ts files.
set(MEDIAELCH_TS_FILES
    "${CMAKE_SOURCE_DIR}/data/i18n/MediaElch_bg.ts"
    "${CMAKE_SOURCE_DIR}/data/i18n/MediaElch_cs_CZ.ts"
    "${CMAKE_SOURCE_DIR}/data/i18n/MediaElch_da.ts"
    "${CMAKE_SOURCE_DIR}/data/i18n/MediaElch_de.ts"
    "${CMAKE_SOURCE_DIR}/data/i18n/MediaElch_en.ts"
    # See https://github.com/Komet/MediaElch/issues/1191#issuecomment-789104632
    # Locale resolution is stupid...
    # "${CMAKE_SOURCE_DIR}/data/i18n/MediaElch_en_US.ts"
    "${CMAKE_SOURCE_DIR}/data/i18n/MediaElch_es_ES.ts"
    "${CMAKE_SOURCE_DIR}/data/i18n/MediaElch_fi.ts"
    "${CMAKE_SOURCE_DIR}/data/i18n/MediaElch_fr.ts"
    "${CMAKE_SOURCE_DIR}/data/i18n/MediaElch_it.ts"
    "${CMAKE_SOURCE_DIR}/data/i18n/MediaElch_ja.ts"
    "${CMAKE_SOURCE_DIR}/data/i18n/MediaElch_ko.ts"
    "${CMAKE_SOURCE_DIR}/data/i18n/MediaElch_nl_NL.ts"
    "${CMAKE_SOURCE_DIR}/data/i18n/MediaElch_no.ts"
    "${CMAKE_SOURCE_DIR}/data/i18n/MediaElch_pl.ts"
    "${CMAKE_SOURCE_DIR}/data/i18n/MediaElch_pt_BR.ts"
    "${CMAKE_SOURCE_DIR}/data/i18n/MediaElch_pt_PT.ts"
    "${CMAKE_SOURCE_DIR}/data/i18n/MediaElch_ru.ts"
    "${CMAKE_SOURCE_DIR}/data/i18n/MediaElch_sv.ts"
    "${CMAKE_SOURCE_DIR}/data/i18n/MediaElch_zh_CN.ts"
)
# Where to put the generated *.qm files.  Because MediaElch's data/i18n.qrc file
# uses relative paths, the structure in the build directory must be the same as
# specified in the i18n.qrc file.
set_source_files_properties(
  ${MEDIAELCH_TS_FILES} PROPERTIES OUTPUT_LOCATION "${CMAKE_BINARY_DIR}/i18n"
)
if(NOT Qt6_FOUND)
  qt5_add_translation(MEDIAELCH_QM_FILES ${MEDIAELCH_TS_FILES})
else()
  qt_add_translation(MEDIAELCH_QM_FILES ${MEDIAELCH_TS_FILES})
endif()

# Copy the i18n.qrc because all referenced files are resolved relatively to it.
configure_file(data/i18n.qrc ${CMAKE_BINARY_DIR} COPYONLY)

# -----------------------------------------------------------------------------
# Subdirectories and main executable

add_subdirectory(docs)
add_subdirectory(third_party EXCLUDE_FROM_ALL)
add_subdirectory(src)

add_executable(
  mediaelch ${CMAKE_BINARY_DIR}/i18n.qrc ${MEDIAELCH_QM_FILES} src/main.cpp
)

target_link_libraries(mediaelch PRIVATE libmediaelch)
set_target_properties(mediaelch PROPERTIES OUTPUT_NAME "MediaElch")
mediaelch_post_target_defaults(mediaelch)

# ------------------------------------------------------------------------------
# Installation
install(TARGETS mediaelch RUNTIME DESTINATION bin RENAME MediaElch)
install(FILES data/desktop/MediaElch.desktop DESTINATION share/applications)
install(FILES data/desktop/MediaElch.png DESTINATION share/pixmaps)
install(
  FILES data/desktop/com.kvibes.MediaElch.metainfo.xml
  DESTINATION share/metainfo
)

# ------------------------------------------------------------------------------
# Testing
if(Qt${QT_VERSION_MAJOR}Test_DIR)
  include(CTest)
  include(Catch)
  enable_testing() # Per CMake documentation, enable_testing() must be called in
  # the root directory.
  add_subdirectory(test)
else()
  message(WARNING "Could not find Qt::Test => Tests will not be build!")
endif()

# ------------------------------------------------------------------------------
# Packaging

include(InstallRequiredSystemLibraries)

# As per https://cmake.org/cmake/help/latest/module/CPack.html Only set
# variables that don't have correct default options.

# cmake-format: off
set(CPACK_PACKAGE_NAME              "MediaElch")              # Use upper-case name
set(CPACK_PACKAGE_VENDOR            "kvibes")                 # Be consistent with e.g. the config directory
set(CPACK_PACKAGE_CONTACT           "info@andremeyering.de")  # Current maintainer
set(CPACK_PACKAGE_DESCRIPTION       "${PROJECT_DESCRIPTION}")
set(CPACK_PACKAGE_INSTALL_DIRECTORY "MediaElch")
set(CPACK_PACKAGE_ICON              "${CMAKE_CURRENT_SOURCE_DIR}/MediaElch.ico")
set(CPACK_RESOURCE_FILE_LICENSE     "${CMAKE_CURRENT_SOURCE_DIR}/COPYING")
set(CPACK_RESOURCE_FILE_README      "${CMAKE_CURRENT_SOURCE_DIR}/README.md")
set(CPACK_RESOURCE_FILE_WELCOME     "${CMAKE_CURRENT_SOURCE_DIR}/data/installer/welcome.txt")

set(CPACK_PACKAGE_EXECUTABLES "mediaelch;MediaElch") # MediaElch is an alias for
                                                     # mediaelch. Used by NSIS

# Ignore these files when creating a source package.
# Essentially just our .gitignore and a few other files.
set(CPACK_SOURCE_IGNORE_FILES "/\\\\.git/"      # We don't need git files
                              "\\\\.swp$"
                              "\\\\.DS_Store$"
                              "/.ci/"           # CI files
                              "/build.*/"       # Any build executables
                              "/ZenLib/"
                              "/MediaInfoDLL/"
                              "/docs/user/"     # Git submodule
                              "/scripts/"       # scripts and generated data
                              "/\\\\.github/"   # issue templates, etc.
                              "\\\\.#"
                              ".*AppImage$"
                              ".*\\\\.user.*"
                              "/#"
                              ".*~")
# cmake-format: on

if(APPLE AND NOT CPACK_GENERATOR)
  set(CPACK_GENERATOR "Bundle")
elseif(WIN32 AND NOT CPACK_GENERATOR)
  set(CPACK_GENERATOR "ZIP")
elseif(NOT CPACK_GENERATOR)
  set(CPACK_GENERATOR "TGZ")
endif()

if(WIN32 AND NOT CPACK_SOURCE_GENERATOR)
  set(CPACK_SOURCE_GENERATOR "ZIP")
else()
  set(CPACK_SOURCE_GENERATOR "TGZ")
endif()

include(CPack)

=== src/CMakeLists.txt ===
add_library(libmediaelch)

add_subdirectory(cli)
add_subdirectory(concerts)
add_subdirectory(data)
add_subdirectory(export)
add_subdirectory(file)
add_subdirectory(globals)
add_subdirectory(image)
add_subdirectory(imports)
add_subdirectory(log)
add_subdirectory(media_centers)
add_subdirectory(movies)
add_subdirectory(network)
add_subdirectory(music)
add_subdirectory(renamer)
add_subdirectory(scrapers)
add_subdirectory(settings)
add_subdirectory(tv_shows)
add_subdirectory(ui)

target_link_libraries(
  libmediaelch
  PUBLIC
    Qt${QT_VERSION_MAJOR}::Concurrent
    Qt${QT_VERSION_MAJOR}::Core
    Qt${QT_VERSION_MAJOR}::Gui
    Qt${QT_VERSION_MAJOR}::Multimedia
    Qt${QT_VERSION_MAJOR}::MultimediaWidgets
    Qt${QT_VERSION_MAJOR}::Network
    Qt${QT_VERSION_MAJOR}::OpenGL
    Qt${QT_VERSION_MAJOR}::Qml
    Qt${QT_VERSION_MAJOR}::Quick
    Qt${QT_VERSION_MAJOR}::QuickWidgets
    Qt${QT_VERSION_MAJOR}::Svg
    Qt${QT_VERSION_MAJOR}::Sql
    Qt${QT_VERSION_MAJOR}::Widgets
    Qt${QT_VERSION_MAJOR}::Xml
  PRIVATE
    quazip5
    # MediaElch object libraries
    mediaelch_concert
    mediaelch_data
    mediaelch_downloads
    mediaelch_export
    mediaelch_file
    mediaelch_globals
    mediaelch_image
    mediaelch_image_providers
    mediaelch_log
    mediaelch_mediacenter
    mediaelch_movies
    mediaelch_music
    mediaelch_network
    mediaelch_renamer
    mediaelch_scrapers
    mediaelch_scraper_scraper_tmdb
    mediaelch_scraper_imdb_api
    mediaelch_scraper_movie_aebn
    mediaelch_scraper_movie_ade
    mediaelch_scraper_movie_custom
    mediaelch_scraper_movie_hotmovies
    mediaelch_scraper_movie_imdb
    mediaelch_scraper_movie_ofdb
    mediaelch_scraper_movie_tmdb
    mediaelch_scraper_movie_videobuster
    mediaelch_scraper_tv_custom
    mediaelch_scraper_tv_thetvdb
    mediaelch_scraper_tv_imdb
    mediaelch_scraper_tv_tmdb
    mediaelch_scraper_tv_tvmaze
    mediaelch_settings
    mediaelch_tvShows
    mediaelch_ui
    mediaelch_ui_smallwidgets
    mediaelch_ui_concerts
    mediaelch_ui_movies
    mediaelch_ui_shows
    mediaelch_ui_downloads
    mediaelch_ui_export
    mediaelch_ui_image
    mediaelch_ui_main
    mediaelch_ui_music
    mediaelch_ui_notifications
    mediaelch_ui_settings
)

# DL open/close
if(UNIX)
  target_link_libraries(libmediaelch PRIVATE curl)
  if(NOT APPLE)
    # libmediainfo requires dlopen/dlclose
    target_link_libraries(libmediaelch PRIVATE ${CMAKE_DL_LIBS})
  endif()
endif()

if(APPLE)
  find_library(FOUNDATION Foundation)
  mark_as_advanced(FOUNDATION)
  if(NOT FOUNDATION)
    message(FATAL_ERROR "Foundation framework not found")
  endif()
  target_link_libraries(libmediaelch PRIVATE "${FOUNDATION}")
endif()

# ------------------------------------------------------------------------------
# Sources
target_sources(libmediaelch PUBLIC ../data/MediaElch.qrc ../ui.qrc)

target_sources(libmediaelch PRIVATE qml/AlbumImageProvider.cpp)

mediaelch_post_target_defaults(libmediaelch)

=== third_party/CMakeLists.txt ===
if(USE_EXTERN_QUAZIP)
  # The system's quazip, e.g. libquazip5-dev on Ubuntu
  message(STATUS "Using system's QuaZip library")
  add_library(quazip5 SHARED IMPORTED)

else()
  find_package(ZLIB REQUIRED)

  add_library(quazip5 STATIC)

  target_include_directories(quazip5 SYSTEM INTERFACE .)
  target_include_directories(quazip5 PRIVATE quazip/quazip)
  target_compile_definitions(quazip5 PRIVATE QUAZIP_BUILD)
  target_compile_options(quazip5 PRIVATE -w) # Disable warnings for third-party
                                             # software

  target_sources(
    quazip5
    PRIVATE
      quazip/quazip/ioapi.h
      quazip/quazip/JlCompress.cpp
      quazip/quazip/JlCompress.h
      quazip/quazip/minizip_crypt.h
      quazip/quazip/qioapi.cpp
      quazip/quazip/quaadler32.cpp
      quazip/quazip/quaadler32.h
      quazip/quazip/quachecksum32.h
      quazip/quazip/quacrc32.cpp
      quazip/quazip/quacrc32.h
      quazip/quazip/quagzipfile.cpp
      quazip/quazip/quagzipfile.h
      quazip/quazip/quaziodevice.cpp
      quazip/quazip/quaziodevice.h
      quazip/quazip/quazip.cpp
      quazip/quazip/quazip.h
      quazip/quazip/quazip.pri
      quazip/quazip/quazip.pro
      quazip/quazip/quazip.sln
      quazip/quazip/quazip.vcproj
      quazip/quazip/quazip.vcxproj
      quazip/quazip/quazip.vcxproj.filters
      quazip/quazip/quazip_global.h
      quazip/quazip/quazipdir.cpp
      quazip/quazip/quazipdir.h
      quazip/quazip/quazipfile.cpp
      quazip/quazip/quazipfile.h
      quazip/quazip/quazipfileinfo.cpp
      quazip/quazip/quazipfileinfo.h
      quazip/quazip/quazipnewinfo.cpp
      quazip/quazip/quazipnewinfo.h
      quazip/quazip/run_moc.bat
      quazip/quazip/unzip.c
      quazip/quazip/unzip.h
      quazip/quazip/zip.c
      quazip/quazip/zip.h
  )

  target_link_libraries(quazip5 PUBLIC Qt${QT_VERSION_MAJOR}::Core ZLIB::ZLIB)
  # We don't want e.g. clang-tidy warnings to quazip
  set_target_properties(quazip5 PROPERTIES CXX_CLANG_TIDY "")
endif()

=== src/concerts/CMakeLists.txt ===
add_library(
  mediaelch_concert OBJECT
  Concert.cpp ConcertController.cpp ConcertFileSearcher.cpp ConcertModel.cpp
  ConcertProxyModel.cpp
)

target_link_libraries(
  mediaelch_concert
  PRIVATE Qt${QT_VERSION_MAJOR}::Core Qt${QT_VERSION_MAJOR}::Widgets
          Qt${QT_VERSION_MAJOR}::Multimedia Qt${QT_VERSION_MAJOR}::Sql
)
mediaelch_post_target_defaults(mediaelch_concert)

=== src/data/CMakeLists.txt ===
add_library(
  mediaelch_data OBJECT
  Actor.cpp
  ActorModel.cpp
  Certification.cpp
  Database.cpp
  ImageCache.cpp
  ImdbId.cpp
  Locale.cpp
  MediaInfoFile.cpp
  MediaStatusColumn.cpp
  Rating.cpp
  RatingModel.cpp
  ResumeTime.cpp
  Storage.cpp
  StreamDetails.cpp
  Subtitle.cpp
  TmdbId.cpp
)

target_link_libraries(
  mediaelch_data
  PRIVATE
    Qt${QT_VERSION_MAJOR}::Core Qt${QT_VERSION_MAJOR}::Concurrent
    Qt${QT_VERSION_MAJOR}::Widgets Qt${QT_VERSION_MAJOR}::Multimedia
    Qt${QT_VERSION_MAJOR}::Sql Qt${QT_VERSION_MAJOR}::Xml
)
mediaelch_post_target_defaults(mediaelch_data)

=== src/export/CMakeLists.txt ===
add_library(
  mediaelch_export OBJECT
  ExportTemplate.cpp ExportTemplateLoader.cpp MediaExport.cpp CsvExport.cpp
  SimpleEngine.cpp TableWriter.cpp
)

target_link_libraries(
  mediaelch_export
  PRIVATE Qt${QT_VERSION_MAJOR}::Core Qt${QT_VERSION_MAJOR}::Widgets
          Qt${QT_VERSION_MAJOR}::Network Qt${QT_VERSION_MAJOR}::Sql quazip5
)
mediaelch_post_target_defaults(mediaelch_export)

=== src/file/CMakeLists.txt ===
add_library(
  mediaelch_file OBJECT FileFilter.cpp NameFormatter.cpp FilenameUtils.cpp
                        Path.cpp
)

target_link_libraries(mediaelch_file PRIVATE Qt${QT_VERSION_MAJOR}::Core)
mediaelch_post_target_defaults(mediaelch_file)

=== src/globals/CMakeLists.txt ===
add_library(
  mediaelch_globals OBJECT
  ComboDelegate.cpp
  Containers.cpp
  DownloadManager.cpp
  DownloadManagerElement.cpp
  Filter.cpp
  Globals.cpp
  Helper.cpp
  ImageDialog.cpp
  ImagePreviewDialog.cpp
  Manager.cpp
  MessageIds.cpp
  Meta.cpp
  Math.cpp
  Poster.cpp
  Random.cpp
  ScraperInfos.cpp
  ScraperResult.cpp
  ScraperManager.cpp
  Time.cpp
  TrailerDialog.cpp
  VersionInfo.cpp
)

target_link_libraries(
  mediaelch_globals
  PRIVATE
    Qt${QT_VERSION_MAJOR}::Core
    Qt${QT_VERSION_MAJOR}::Gui
    Qt${QT_VERSION_MAJOR}::Multimedia
    Qt${QT_VERSION_MAJOR}::Widgets
    Qt${QT_VERSION_MAJOR}::Sql
    Qt${QT_VERSION_MAJOR}::Xml
    Qt${QT_VERSION_MAJOR}::MultimediaWidgets
    Qt5::Test
)
mediaelch_post_target_defaults(mediaelch_globals)

=== src/image/CMakeLists.txt ===
add_library(
  mediaelch_image OBJECT Image.cpp ImageCapture.cpp ImageModel.cpp
                         ImageProxyModel.cpp ThumbnailDimensions.cpp
)

target_link_libraries(
  mediaelch_image
  PRIVATE Qt${QT_VERSION_MAJOR}::Widgets Qt${QT_VERSION_MAJOR}::Multimedia
          Qt${QT_VERSION_MAJOR}::Sql
)
mediaelch_post_target_defaults(mediaelch_image)

=== src/imports/CMakeLists.txt ===
add_library(
  mediaelch_downloads OBJECT DownloadFileSearcher.cpp Extractor.cpp
                             FileWorker.cpp MakeMkvCon.cpp MyFile.cpp
)

target_link_libraries(
  mediaelch_downloads
  PRIVATE
    Qt${QT_VERSION_MAJOR}::Core Qt${QT_VERSION_MAJOR}::Widgets
    Qt${QT_VERSION_MAJOR}::Multimedia Qt${QT_VERSION_MAJOR}::Sql
    Qt${QT_VERSION_MAJOR}::Xml
)
mediaelch_post_target_defaults(mediaelch_downloads)

=== src/log/CMakeLists.txt ===
add_library(mediaelch_log OBJECT Log.cpp)

# GUI is required due to Globals.h Network due to HttpStatusCodes.h
target_link_libraries(
  mediaelch_log
  PRIVATE Qt${QT_VERSION_MAJOR}::Core Qt${QT_VERSION_MAJOR}::Widgets
          Qt${QT_VERSION_MAJOR}::Network
)
mediaelch_post_target_defaults(mediaelch_log)

=== src/media_centers/CMakeLists.txt ===
add_library(
  mediaelch_mediacenter OBJECT
  kodi/KodiXmlWriter.cpp
  kodi/AlbumXmlReader.cpp
  kodi/AlbumXmlWriter.cpp
  kodi/ArtistXmlReader.cpp
  kodi/ArtistXmlWriter.cpp
  kodi/ConcertXmlReader.cpp
  kodi/ConcertXmlWriter.cpp
  kodi/EpisodeXmlReader.cpp
  kodi/EpisodeXmlWriter.cpp
  kodi/MovieXmlReader.cpp
  kodi/MovieXmlWriter.cpp
  kodi/TvShowXmlReader.cpp
  kodi/TvShowXmlWriter.cpp
  KodiVersion.cpp
  KodiXml.cpp
  MediaCenterInterface.cpp
)
target_link_libraries(
  mediaelch_mediacenter
  PRIVATE Qt${QT_VERSION_MAJOR}::Network Qt${QT_VERSION_MAJOR}::Widgets
          Qt${QT_VERSION_MAJOR}::Sql Qt${QT_VERSION_MAJOR}::Xml
)
mediaelch_post_target_defaults(mediaelch_mediacenter)

=== debian/changelog ===
mediaelch (2.8.8.2-1~bionic) bionic; urgency=medium

  * next build

 -- Andre Meyering <info@andremeyering.de>  Mon, 26 Apr 2021 18:03:46 +0200

mediaelch (2.8.6.1-1~bionic) bionic; urgency=medium

  * next build

 -- Andre Meyering <info@andremeyering.de>  Fri, 22 Jan 2021 13:34:28 +0100

mediaelch (2.8.4.1-1~bionic) bionic; urgency=medium

  * next build

 -- Andre Meyering <info@andremeyering.de>  Sat, 09 Jan 2021 11:12:48 +0100

mediaelch (2.8.2.1-1~bionic) bionic; urgency=medium

  * next build

 -- Andre Meyering <info@andremeyering.de>  Sun, 20 Dec 2020 13:14:07 +0100

mediaelch (2.8.2-1) vivid; urgency=low

  * Update to MediaElch v2.8.2

 -- Andre Meyering <info@andremeyering.de>  Sun, 20 Dec 2020 12:00:00 +0200

mediaelch (2.8.0-1) vivid; urgency=low

  * Update to MediaElch v2.8.0

 -- Andre Meyering <info@andremeyering.de>  Sun, 13 Dec 2020 12:00:00 +0200


 mediaelch (2.6.6-1) vivid; urgency=low

  * Fix AEBN crash when scraping a movie (#910)
  * Select correct language for TMDb in the movie search dialog (#916)
  * Windows: Fix scanning of concerts (#814)
  * Downloads Section: Fix crash when importing items (#828)
  * Downloads Section: Fix invalid file sizes (#829)
  * TV episodes: Manually edited writers and directors were not saved (#933)
  * TV shows: Fix TV shows always being reloaded from disk (#732)
  * UI: Fix text color in messages boxes (#942)
  * HotMovies: Fix rating scraping
  * Trailer Download: Fix downloading trailers for many movies (#940)
  * TV Tunes Download: Fix crash when aborting download and restarting it (#940)
  * Movie: Don't save runtime from file if it cannot be detected (#604)
  * TV show file searcher now allows spaces between episode and season (#513)
  * Image Preview: Fix centering of image dialog (#863)
  * Export: The generated folder name now also contains seconds (#935)
  * Always write the episode guide URL to TV show NFOs using TheTvDb format (#652)
  * Fanart.tv: Print better error messages for shows and movies that cannot be found (#900)
  * TMDb: Update available languages to support official translations (#901)
  * Movies: If movies are sorted by "name", the movie's sort title is used if
    set and the name otherwise (#919)
  * IMDb: Use higher image resolution for actors (#920)
  * Movie Poster: Make it possible to set a random screenshot as the movie's poster (#934)
  * TV show: Also load TV show posters when searching for new season posters (#600)
  * TV show: Remove suffix (e.g. `.mkv`) from default episode names (#513)
  * Set MediaElch specific HTTP User-Agent header for most HTTP requests (#912)
  * Updater: Use new MediaElch meta repository for version checks (#896)
  * Download Section: Refactor the file searcher to make it non-blocking and
    improve the overall performance (#830)
  * Logging: Respect `QT_MESSAGE_PATTERN` and use better defaults
  * Replace all old-style `SIGNAL`/`SLOT` connections with new-style ones.

 -- Andre Meyering <info@andremeyering.de>  Sat, 18 Apr 2020 12:00:00 +0200


 mediaelch (2.6.4-1) vivid; urgency=low

  * Fix TV shows sorting and possible crashes if "Show missing episodes" is enabled (#789, #883)
  * Fix hanging window if the custom movie scraper is selected but no valid scraper is found.
  * Fix `{{ *.RATING }}` not being replaced in exports if a media item has no rating
  * Fix movie label color not being shown (#803)
  * Fix default language selection in movie scraper dialog
  * NFO: Only write `<originaltitle>` if it's different from `<title>` (#812)
  * Fix IMDb runtime scraping (#810)
  * Update TMDb base URL for downloading images (#807)
    The very old subdomain has been taken offline. We now use the new one.
  * Fix TMDb scraper language in dialog window (#813)
    Scraper language wasn't the one saved in settings but always "English".
  * About Dialog: Fix MediaInfo version string in developer information (#790)
  * Movie/TvShow: Only parse valid `premiered` tags (#827)
  * Fix crash when no TV show is selected
  * Fix missing TheTvDb ID in episode NFO files (#788)
  * Don't write TheTvDb v1 episode-guide URLs to TV show NFOs (#652)
  * Show "Dolby TrueHD" media flag for "truehd" audio codec
  * Fix audio codec recognition for newer MediaInfoLib versions (#797)
  * Fix "Add to synchronization queue" feature for episodes and TV shows (#850)
  * Allow IMDb IDs with 8 digits (previously only 7 digits allows) (#855)
  * Fix actors having wrong image after removing one actor (#859)
  * TMDb: Load more movie collection details (#800)
  * ADA search: Don't filter for DVDs, fix overview scraping of some movies (#819)
  * Movie Search Dialog: Add error message label
  * TheTvDb: Use API v2 (JSON API instead of old XML API) (#487, #432, #528)
  * Episode widget: add TheTvDb ID and IMDb ID fields
  * AdvancedSettings: Better input validation (issues are printed to the debug log) (#743)
  * AdvancedSettings: Add experimental exclude patterns (#840)
  * Add `en_US` language file for better singular/plural handling
  * Better network error reporting for scraping TV shows and movies (#870)
  * Better error reporting in the image dialog (#864, #874)

 -- Andre Meyering <info@andremeyering.de>  Sun, 8 Feb 2020 12:00:00 +0200

mediaelch (2.6.2-1) vivid; urgency=low

  * Fix IMDb tag scraping (#649)
  * Fix TMDb issue with HTML characters in overview/plot (#651)
  * `Ctrl+A` works in movie and concert section (#647)
  * Fix crash when "Load missing episodes" is enabled (#669)
  * Filter "Movie has no IMDb ID" is inversed (#680)
  * Window positions not saved (#679)
  * Country mappings not used in TMDb (#689)
  * Windows: Stream Details do not load (#688)
  * Crashes on macOS when scanning episodes due to a Qt bug (#641)
  * Fix ADE scraper (#703, #725)
  * Fix TV shows always beeing reloaded (#732)
  * Fix incompatibilities with Kodi v17 NFO files (#719)
  * Fix race-condition in DownloadManager (#766)
  * Update French translation (#646)
  * Add more subtitle formats (#661)


=== PKGBUILD ===
# Maintainer: Levente Polyak <anthraxx[at]archlinux[dot]org>
# Contributor: Matt Harrison <matt@mistbyte.com>

pkgname=mediaelch
pkgver=2.8.12
pkgrel=1
pkgdesc='Media Manager for handling Movies, TV Shows and Concerts/Music Videos for Kodi'
url='https://www.mediaelch.de/mediaelch/'
arch=('x86_64')
license=('LGPL3')
depends=('glibc' 'gcc-libs' 'libmediainfo' 'qt5-declarative' 'qt5-multimedia'
         'qt5-script' 'qt5-svg' 'quazip')
makedepends=('cmake' 'ninja' 'qt5-tools')
source=(https://github.com/Komet/MediaElch/archive/v${pkgver}/${pkgname}-${pkgver}.tar.gz)
sha256sums=('c3f30fb18ad496057984ea7ea2593710ec4069eda1f4324ba10dffb66a5c3a75')
b2sums=('f0c8afa6b12988621d339b5c6b56d7dd4354d61598a2cb26a2f4a75784d197aad5e2d425d59032b174efb57b079ec9a9fd948553e74f5e1bcea8b49a494dc047')

prepare() {
  cd MediaElch-${pkgver}
  sed 's|quazip5/|QuaZip-Qt5-1.1/quazip/|g' -i src/*/*.cpp src/*/*.h
  sed 's|quazip5|quazip1-qt5|g' -i */CMakeLists.txt */*/CMakeLists.txt MediaElch.pro
}

build() {
  cd MediaElch-${pkgver}
  cmake -B build \
    -DCMAKE_INSTALL_PREFIX=/usr \
    -DCMAKE_BUILD_TYPE=None \
    -DDISABLE_UPDATER=ON \
    -DUSE_EXTERN_QUAZIP=ON \
    -Wno-dev \
    -G Ninja
  ninja -C build
}

package() {
  cd MediaElch-${pkgver}
  DESTDIR="${pkgdir}" ninja -C build install
}

# vim: ts=2 sw=2 et:

=== debian/control ===
Source: mediaelch
Section: misc
Priority: extra
Maintainer: Andre Meyering <info@andremeyering.de>
Build-Depends: debhelper (>= 8.0.0), qtchooser, qtbase5-dev, qtbase5-dev-tools, qt5-qmake, qtmultimedia5-dev, qt5-qmake, cdbs, libmediainfo0 | libmediainfo0v5, libmediainfo-dev, zlib1g-dev, libzen-dev, libcurl4-openssl-dev | libcurl4-gnutls-dev, libpulse-dev, libqt5quickwidgets5, libqt5qml5, qtdeclarative5-dev, libqt5quick5, libqt5opengl5-dev, libqt5svg5-dev, qttools5-dev, qttools5-dev-tools
Standards-Version: 4.1.4
Homepage: http://www.mediaelch.de
Vcs-Git: git://github.com/Komet/MediaElch.git

Package: mediaelch
Architecture: any
Depends: ${shlibs:Depends}, ${misc:Depends}, libqt5sql5, libqt5sql5-sqlite, libqt5core5 | libqt5core5a, libqt5gui5, libqt5network5, libqt5concurrent5, libqt5svg5, libqt5graphicaleffects5 | libqt5qml-graphicaleffects | qml-module-qtgraphicaleffects, qml-module-qtquick-controls, qml-module-qtqml-models2, libqt5qml5, libqt5multimedia5, libqt5multimediawidgets5, libqt5opengl5, libqt5xml5, libmediainfo0 | libmediainfo0v5, zlib1g, libzen0 | libzen0v5, libcurl3 | libcurl4, libpulse0, libqt5quickwidgets5, libqt5quick5
Description: Kodi Media Manager
 MediaElch is your Media Manager for handling movies, TV shows, concerts and
 music in Kodi. It is designed to gather information from various movie
 databases on the internet and store these information directly to Kodis
 database or in nfo files. MediaElch is also downloading movie posters,
 backdrops, fan arts and pictures of the actors.

=== debian/rules ===
#!/usr/bin/make -f

QT_SELECT=qt5

include /usr/share/cdbs/1/rules/debhelper.mk
include /usr/share/cdbs/1/class/qmake.mk
